; GREET.ASM
;
; Written by Scott R. Houck    22 May 86
;
; This program will display the date and time with an
; appropriate greeting to whoever is to be greeted.
;
; Syntax:  GREET [name]
;

cseg		segment para public 'code'
		assume	cs:cseg, ds:cseg, ss:cseg
		org	100h
entpt:		jmp	start

cr		equ	13
lf		equ	10

greet1		db	lf, 'Good morning$'
greet2		db	lf, 'Good afternoon$'
greet3		db	lf, 'Good evening$'

opening		db	'Today is $'

period		db	'.', cr, lf, lf, '$'

currtime	db	'The current time is $'

am_pm		db	' a.m.', cr, lf, '$'

tenb		db	10		;10 as a byte
tenw		dw	10		;10 as a word

days		db	'Sunday$   '
		db	'Monday$   '
		db	'Tuesday$  '
		db	'Wednesday$'
		db	'Thursday$ '
		db	'Friday$   '
		db	'Saturday$ '

months		db	'January$  '
		db	'February$ '
		db	'March$    '
		db	'April$    '
		db	'May$      '
		db	'June$     '
		db	'July$     '
		db	'August$   '
		db	'September$'
		db	'October$  '
		db	'November$ '
		db	'December$ '

start		proc	near
		mov	ah,2ch		;get time function
		int	21h
		push	cx		;save the hours & minutes
		cmp	ch,12		;before noon?
		jl	morning
		cmp	ch,18		;before 6 pm?
		jl	afternoon

		lea	dx,greet3	;ok, must be evening!
		jmp	cont1
afternoon:
		lea	dx,greet2
		jmp	cont1
morning:
		lea	dx,greet1
cont1:
		mov	ah,9
		int	21h		;print the appropriate greeting

		mov	si,80h		;PSP parameter byte count pointer
		mov	cl,[si]
		xor	ch,ch
		jcxz	no_params	;If CX = 0, there are no params
		mov	al,','
		call	stdout
		inc	si
		cld

name:
		lodsb			;print out the command
		call	stdout		;  line parameter
		loop	name

no_params:
		mov	al,'!'
		call	stdout
		mov	al,cr
		call	stdout
		mov	al,lf
		call	stdout
		mov	al,lf
		call	stdout
	
		lea	dx,opening
		mov	ah,9		
		int	21h		;print the opening

		mov     ah,2ah		;get date function
		int	21h
		push	cx		;save CX (year)
		push	dx		;save DX (DH = month, DL = day)

;The day of the week is stored in AL, where 0 = Sunday, 1 = Monday, etc.

		lea	dx,days
		mul	tenb		;AX = 10 * AL
		add	dx,ax		;DX is now the DOW offset
		mov	ah,9
		int	21h		;print the day of the week

		mov	al,','		;output a comma		
		call	stdout
		mov	al,' '		;output a space
		call	stdout

		pop	cx		;restore the month and day in CX
		lea	dx,months
		dec	ch		;month index
		mov	al,ch
		mul	tenb		;AX = 10 * month index
		add	dx,ax		;DX is now the month name offset
		mov	ah,9
		int	21h		;print the month name

		mov	al,' '		;print a space
		call	stdout

		mov	al,cl		;the day was saved in CL
		cbw			
		call	decimal_out	;print the day

		mov	al,','		;output a comma		
		call	stdout
		mov	al,' '		;output a space
		call	stdout

		pop	ax		;the year
		call	decimal_out

		lea	dx,period	;print a period and cr/lf
		mov	ah,9
		int	21h

		lea	dx,currtime	;start current time message
		mov	ah,9
		int	21h

		pop	cx		;CH = hours, CL = minutes
		cmp	ch,12		;is it a.m. or p.m.?
		jl	cont2
		sub	ch,12
		mov	am_pm[1],'p'
cont2:
		mov	al,ch
		cbw
		cmp	ax,0
		jne	cont3
		add	ax,12		;adjust for 12 a.m.
cont3:
		call	decimal_out	;print the hours

		mov	al,':'
		call	stdout		;print a colon
		
		mov	al,cl		
		cbw
		cmp	ax,9
		jg	print_mins
		push	ax
		mov	al,'0'		;print a zero if mins < 10
		call	stdout
		pop	ax
print_mins:
		call	decimal_out	;print the minutes

		lea	dx,am_pm	;print a.m. or p.m.
		mov	ah,9
		int	21h

		int	20h		;return to DOS
start		endp

;--------------------------------------------------------------------------
; Output a single character to the screen.
; Upon entry, the character to be printed is in AL.
; AH is modified.

stdout		proc	near
		push	dx		;save DX
		mov	dl,al		;character to output
		mov	ah,2		;output character function
		int	21h
		pop	dx		;restore DX
		ret
stdout		endp

;--------------------------------------------------------------------------
; Output a hex word in decimal
; Upon entry, the number to be printed is in AX.

decimal_out 	proc 	near
		push	ax		;save registers
		push	cx
		push	dx
	        mov	cx,0		;counts digits to print
another_digit:
		inc	cx		;increment counter
		mov	dx,0		;prepare to divide
		div	tenw		;divide by ten
		push	dx		;remainder is least sig digit
		cmp	ax,0		;is the quotient zero?
		jne	another_digit	;if not, more numbers to convert
print_digits:
		pop	ax		;retrieve digit from stack
		add	al,'0'		;convert to ASCII
		call	stdout		;print the character
		loop	print_digits	;do all of the digits
		pop	dx		;restore the registers
		pop	cx
		pop	ax
		ret
decimal_out	endp

;--------------------------------------------------------------------

cseg		ends
		end	entpt
